# -*- coding:utf-8 -*-
# Author: Bingning Wang (王炳宁)
# Email: research@bingning.wang
# HomePage: www.bingning.wang
# Date: 2017/10/25 0025 下午 1:15
from tqdm import tqdm

from model import *
from public_functions import *
from sklearn.metrics import average_precision_score



def get_rr(result):
    pass


def test_IARNN():
    model = IARNN_Context(model_number=1984)
    [function, parameter] = model.build_model(is_test=True)
    data = load_file('data/WikiQACorpus/test.obj')
    total = len(data)
    for i in range(100):
        model.reload_parameter(parameter, i)
        aps = []
        mrr = []
        for one in tqdm(data):
            question = np.asarray([one[0]], dtype='int32')
            output = []
            y_true = [x[1] for x in one[1]]
            y_prediction = []
            for candidates in one[1]:
                label = candidates[1]
                sentence = np.asarray([candidates[0]], dtype='int32')
                score = function(question, sentence)[0]
                y_prediction.append(score)
                output.append([score, label])
            ap = average_precision_score(y_true, y_prediction)
            aps.append(ap)
        print np.mean(aps)

if __name__ == '__main__':
    test_IARNN()
